/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _CDVDFSV_H_
#define _CDVDFSV_H_

#include "../CDVD.h"

/////////////////////////////////////////////////// 80000592
#define CDVD_CDINIT	0

#define SCECdINIT        0x00
#define SCECdINoD        0x01
#define SCECdEXIT        0x05

/////////////////////////////////////////////////// 80000593
#define CDVD_READCLOCK		0x01	//sceCdReadClock
#define CDVD_WRITECLOCK		0x02	//sceCdWriteClock
#define CDVD_GETDISKTYPE 	0x03	//sceCdGetDiskType
#define CDVD_GETERROR		0x04	//sceCdGetError
#define CDVD_TRAYREQ		0x05	//sceCdTrayReq
#define CDVD_READILINK		0x06	//_sceCdRI(read ILink ID)
#define CDVD_WRITEILINK		0x07	//sceCdWriteILinkID
#define CDVD_READNVM		0x08	//readNVM
#define CDVD_WRITENVM		0x09	//writeNVM
#define CDVD_DECSET		0x0a	//DEC SET
#define CDVD_DECSETS		0x0b	//DEC SET(S)
#define CDVD_STATUS		0x0c	//sceCdStatus
#define CDVD_HDMODE		0x0d	//setHDMode
#define CDVD_OPENCONFIG		0x0e	//sceCdOpenConfig
#define CDVD_CLOSECONFIG 	0x0f	//sceCdCloseConfig
#define CDVD_READCONFIG		0x10	//sceCdReadConfig
#define CDVD_WRITECONFIG 	0x11	//sceCdWriteConfig
#define CDVD_READCONSOLE 	0x12	//ReadConsole
#define CDVD_WRITECONSOLE 	0x13	//WriteConsoleID
#define CDVD_GETMECACON		0x14	//GetMecacon
#define CDVD_CTRLAUDDIGOUT 	0x15	//CtrlAudioDigitalOut
#define CDVD_BREAK		0x16	//sceCdBreak
#define CDVD_READSUBQ		0x17	//ReadSUBQ 
#define CDVD_FORBIDDVDP		0x18	//ForbidDVDP
#define CDVD_AUTOADJUST		0x19	//AutoAdjustCtrl 
#define CDVD_RM			0x1a	//_sceCdRM
#define CDVD_WM			0x1b	//_sceCdWM
#define CDVD_POWEROFF		0x21	//sceCdPowerOff
#define CDVD_MMODE		0x22	//sceCdMmode
#define CDVD_CHANGETHREADPRIO	0x23	//sceCdChangeThreadPriority

/////////////////////////////////////////////////// 80000595
#define CDVD_READ		0x01	//sceCdRead
#define CDVD_READ2		0x02	//cdvdman_call40
#define	CDVD_READVD		0x03	//cdvdman_sceDvdRead
#define CDVD_GETTOC		0x04	//sceCdGetToc
#define CDVD_SEEK		0x05	//sceCdSeek
#define CDVD_STANDBY		0x06	//sceCdStandby 
#define CDVD_STOP		0x07	//sceCdStop
#define CDVD_PAUSE		0x08	//sceCdPause 
#define CDVD_STREAD		0x09	//sceCdStRead
#define CDVD_STREADA		0x0a	//CD STREAM related(2) 
#define CDVD_READKEY		0x0b	//READ KEY
#define CDVD_APPLYNCMD		0x0c	//sceCdApplyNCmd 
#define CDVD_READIOPM		0x0d	//sceCdReadIOPm
#define CDVD_NCMDDISKREADY	0x0e	//sceCdNcmdDiskReady
#define CDVD_READCHAIN		0x0f	//sceCdReadChain

struct CDREAD{
	int  lsn;			//+00
	int  sectors;		//+04
	void *buf;			//+08
	CdRMode mode;		//+0C
	void *_rd_intr_data;	//+10
	void *_Read_cur_pos;	//+14
};

/////////////////////////////////////////////////// 80000596
#define CDVD_PowerOffCB		0x01

/////////////////////////////////////////////////// 80000597
#define CDVD_SEARCHFILE		0x00

#if defined(__WIN32__)
#pragma pack(1)
#endif

// Old Library
struct cdvdfsv_SEARCHFILE{	//(sizeof=0x124)
	CdlFILE	fp;		//+000
	char	name[256];	//+020
	void	*dest;		//+120
#if defined(__WIN32__)
};
#else
} __attribute__((packed));
#endif

// Not_Dual_layer Version
struct cdvdfsv_SEARCHFILE2{	//(sizeof=0x128)
	CdlFILE	fp;		//+000
	int	field_20;	//+020
	char	name[256];	//+024
	void	*dest;		//+124
#if defined(__WIN32__)
};
#else
} __attribute__((packed));
#endif

// Dual_layer Version
struct cdvdfsv_SEARCHFILE3{	//(sizeof=0x12C)
	CdlFILE	fp;		//+000
	int	field_20;	//+020
	char	name[256];	//+024
	void	*dest;		//+124
	int	layer;		//+128
#if defined(__WIN32__)
};
#else
} __attribute__((packed));
#endif

#if defined(__WIN32__)
#pragma pack()
#endif

/////////////////////////////////////////////////// 8000059A
#define CDVD_DISKREADY		0x00	//sceCdDiskReady

#endif//_CDVDFSV_H_


